/**
 * @file
 * @brief lzc add 20211119
 */
#pragma once
#include "PD_LatTrajectory.h"
#include "PD_LgtTrajectory.h"
#include <vector>
// #include "../include/mpc_drv_ctAp_pd/BehaviorNodeLocal.h"
// #include "mpc_drv_msgs/msg/behavior_node_local.hpp"
#include "../../source/PD_commonfunc.h"
#include "PD_LgtSpdLmt.h"
#include "../../../include/CtApBehaviorAnalysis_/interface/pd_interface.h"

namespace ADC
{
    namespace PD_EgoVehTrj

    {
        /**
         * @file  PD_EgovehStsArb
         * @brief Ego Vehicle Trajectory(t,l,s)
         */

        struct EgoVeh_TrjPnt
        {
            float t;   // uint:s
            float l;   // uint:m
            float s;   // unit:m
            float vx;  // uint: m/s
            float ax;  // uint:m/s2
            float jkx; // unit:m/s3
            float vy;  // latspd,unit:m/s
        };

        // struct EgoVeh_LgtTrjPnt
        // {
        //     float t;   // unit:s
        //     float s;   // unit：m
        //     float vx;  // unit:m/s
        //     float ax;  // unit:m/s2
        //     float jkx; // unit:m/s3
        // };
        struct EgoVhe_LgtTrjInfo
        {
            // std::vector<EgoVeh_LgtTrjPnt> egoveh_lgttrjpnt;
            std::vector<PD_LgtTrj_ST_point> egoveh_lgttrjpnt;
            float plan_tm = 0.0f; // lgt trajectory plan time
        };

        class EgoVehTrj
        {

        public:
            // EgoVehTrj();
            // void process(const PD_LgtSpdLmt::LgtSpdLmt &lgtspdlmt);
            void EgoVehTrjArbProc(const PD_LgtSpdLmt::LgtSpdLmt &lgtspdlmt,
                                  const ADC::PD_LgtTrj::LgtTrajectory &lgttrj_st,
                                  const ADC::PD_LatTrj::LatTrajectory &LatTrj_LS_trace,
                                  const PD::PD_Input &pd_input);

            void LgtTrjPntCompProc(const ADC::PD_LgtTrj::LgtTrajectory &lgttrj_st,
                                   const ADC::PD_LatTrj::LatTrajectory &LatTrj_LS_trace,
                                   const PD::PD_Input &pd_input);
            void EgoVehLgtTrjPntProc(const PD_LgtSpdLmt::LgtSpdLmt &lgtspdlmt,
                                     const ADC::PD_LgtTrj::LgtTrajectory &lgttrj_st);

            std::vector<EgoVeh_TrjPnt> egoveh_tp;

            float pd_vehtrajPlanTm = 0.0f;
            // bool ClsnFlag = false;

            EgoVhe_LgtTrjInfo lgt_egoveh_tpinfo;

        private:
            std::vector<EgoVeh_TrjPnt> Fol_egoveh_tp;
        };

    } // namespace PD_EgoVehTraj

} // namespace ADC
